<?php
/*
 * Author: Etienne Gauthier (etienne_sf@sourceforge.net)
 * 
 * Receive a picture uploaded by the jupload.php script (through the JUpload applet)
 * 
 * Up to date version of this script can be retrieved with the full JUpload package, here:
 * 
 * http://etienne.lesgauthier.fr/wiki
 * 
 * Directly here:
 * http://etienne.lesgauthier.fr/wiki/doku.php?id=jupload_coppermine_download_gb
 * 
 * The applet is published on sourceforge:
 * http://jupload.sourceforge.net
 * 
 */


if (!defined('IN_COPPERMINE')) die('Not in Coppermine...');



////////////////////////////////////////////////////////////////////////////////////////////////// 
///////////////////////////   Creation of the JUpload button ///////////////////////////////////// 
/////////////////////  Largely inspired from the photo_summary plugin //////////////////////////// 
////////////////////////////////////////////////////////////////////////////////////////////////// 

//$thisplugin->add_action('plugin_wakeup','jupload_plugin_wakeup'); // ( ...when initialized )
$thisplugin->add_action('page_start','jupload_page_start');

/**
 * The wakeup is the good place to include files.  
 */
function jupload_plugin_wakeup() {
	//if (!defined('JUPLOAD_PHP')) {
		define('JUPLOAD_PHP', true);
	//}
	require_once('plugins/jupload/include/jupload.inc.php');
	
	return true;
}

//This code comes from a sample, given by Sami to Frantz.
//Thanks to both of you !   ;-)
function jupload_page_start()
{
	global $template_sys_menu, $USER, $lang_jupload_php, $JUPLOAD_CONFIG;
	
	define('JUPLOAD_PHP', true);
	require_once('plugins/jupload/include/jupload.inc.php');
	
	//We now have to include again the jupload.inc.php. I don't know exactly what happens in the 
	//Coppermine code! 
	//require('plugins/jupload/include/jupload.inc.php');
	
	if (   ($JUPLOAD_CONFIG['alwaysVisible']==0 && USER_CAN_UPLOAD_PICTURES)
	|| $JUPLOAD_CONFIG['alwaysVisible']==1
	|| ($JUPLOAD_CONFIG['alwaysVisible']==2 && GALLERY_ADMIN_MODE)
	) {
			//Pas de jupload .. ?
		$jupload_section = 'jupload';
		$linkComment = ('' != $JUPLOAD_CONFIG['linkComment']) 
								? $JUPLOAD_CONFIG['linkComment'] 
								: $lang_jupload_php['link_comment'];  
		$linkTitle   = ('' != $JUPLOAD_CONFIG['linkTitle'])   
								? $JUPLOAD_CONFIG['linkTitle']   
								: $lang_jupload_php['link_title'];  
		$category = (isset($_GET['cat'])) 
						? (int)$_GET['cat'] 
						: (
							isset($_GET['category']) 
								? (int)$_GET['category'] 
								: 0
							);
		$album = isset($_GET['album']) ? (int)$_GET['album'] : 0;
		$url = 'index.php?file=jupload/jupload'
			.  ( $category>0 ? "&category=$category" : '')
			.  ( $album>0    ? "&album=$album"       : '')
			;


		//The upload_pic button always exist in $template_sys_menu. The question is just to know if it should
		//be hidden o not ... after the call of this function.
		//We use it as the template for our JUpload button.
		//as template_extract_block changes the given template, we use a opy of the original one 
		$base_template = $template_sys_menu;
		$standard_upload_button = template_extract_block($base_template,'upload_pic');
		//echo("<PRE>$standard_upload_button</PRE><BR>");
		$params = array(
			'{UPL_PIC_LNK}'   => $linkTitle,
			'{UPL_PIC_TITLE}' => $linkComment,
			'{UPL_PIC_TGT}'   => $url,
			'upload_pic'  => $jupload_section,
		);

		//template_eval needs that $params parameters correspond to the given $button.
		$jupload_button = "<!-- BEGIN $jupload_section -->".template_eval($standard_upload_button,$params)."<!-- END $jupload_section -->";
		//echo("<HR><PRE>$jupload_button</PRE><HR><BR>");
		
		//A patch for the 'hardwired' theme, that need the themes/hardwired/images/buttonleftJUpload.gif image
		//This image, of course (hum .. jupload should be everywhere ;-) ), doesn't exist in this theme. So we
		//replace by the faq.gif picture.
		$jupload_button = str_replace('jupload.gif', 'up.gif', $jupload_button);

		//Now: let's build our jupload button.
		//It will contain the standard upload button or not, depending on the answer to these two questions:
		// 1) Should we keep the standard upload button or not ?
		// 2) May the user upload picture? If not, we let Coppermine remove the button.
		if ($JUPLOAD_CONFIG['linkKeepStandardUpload'] || !USER_CAN_UPLOAD_PICTURES) {
			$jupload_button =  "<!-- BEGIN upload_pic -->"
									. $standard_upload_button
									. "<!-- END upload_pic -->\n"
									. $jupload_button;
		}

		//Let's insert the new button in place of the standard upload link. The new button may contain or
		//not the standard upload button, depending on the previous choice.
		template_extract_block($template_sys_menu, 'upload_pic', $jupload_button);
	}
	
	return true;
}
