<?php
/*************************
  Coppermine Photo Gallery
  ************************
  Copyright (c) 2003-2006 Coppermine Dev Team
  v1.1 originally written by Gregory DEMAR

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  ********************************************
  Coppermine version: ?
  $Source: /cvsroot/coppermine/stable/jupload.php,v $
  $Revision: ?
  $Author: Etienne Gauthier
  $Date: ?
**********************************************/

if (!defined('IN_COPPERMINE')) { die('Not in Coppermine...');}
if (!defined('JUPLOAD_PHP')) { die('Not in Jupload...');}

//This file is included within a function (see codebase.php: jupload_plugin_wakeup)
//So, we need to declare all variables that must be global, as such:
global $JUploadParamList, $CONFIG, $JUPLOAD_CONFIG, $configFileHeader, $hint, $parameterPrefix, $config_inc;


//####################################################################################################
//##############################        CONSTANTS      ###############################################
//####################################################################################################

// The $parameterPrefix string will be added at the beginning of each parameter name, before insertion
//into the Coppermine configuration table. 
$parameterPrefix = "jupload_";



//####################################################################################################
//##############################  PARAMETER DEFINITION ###############################################
//####################################################################################################

//These texts will be both displayed on the screen, and written in the configuration file.
//See also the jupload/page/config_page.php file

/*
 * $JUploadParamList is an array of param. Each param contains the following keys:
 * name: the parameter name. It's the key that'll be stored in the $JUPLOAD_CONFIG array.
 * desc: an explanation about the parameter. Only in english. This explanation will only be visible to admins.
 * default: The default value for this parameter.
 * type: the data type for this parameter. Can be 'int' or 'string'. Any unknown value is managed as a string.
 */

$JUploadParamList = array 
(
'alwaysVisible' => array (
	'desc' => <<<EOS
<B>Caution: Signification changed (a little) since v2.4.1</B><BR>
<DIR>
 <LI><U>If set to 0</U>, the JUpload link will only be displayed if the user may upload pictures
 <LI><U>If set to 1</U>, the JUpload link will always be visible, whenever the user may or may not upload pictures.<BR> 
 If the user clicks on it, here is what happens:<BR>
 <DIR>
  <LI>a- If the user may upload pictures, the upload page containing the applet opens,
  <LI>b- If the user is authenticated, but may not upload pictures, an error message is displayed,
  <LI>c- If the user is not authenticated, an error page containing a link to the login page is displayed. Once 
  connected, the user is redirected to the upload page. We go back to step 1, above.
 </DIR>
 <LI><U>If set to 2</U>, the JUpload link will only be displayed if the user is connected and is an administrator 
 of the gallery. 
</DIR>
Other values than 0, 1 or 2 are treated as the default value.
EOS
,
	'default' => '0',
	'type' => 'int'
	)
,
'appletHeight' => array (
	'desc' => <<<EOS
Allows the local administrator, to define a specific height for the applet.
EOS
,
	'default' => '450',
	'type' => 'int'
	)
,
'appletWidth' => array (
	'desc' => <<<EOS
Allows the local administrator, to define a specific width for the applet. This can be useful for theme 
that allows only little place for the 'useful' part of the page, that is ... where the applet is displayed ;-)<BR>
For instance, for the <I>i-feel-dirty</I> them, a width of 450 sould be used instead of the default one.
EOS
,
	'default' => '640',
	'type' => 'int'
	)
,
'basicHttpAuthentication' => array (
	'desc' => <<<EOS
This parameter allows use of basic HTTP authentication in the applet. This authentication can be triggered 
through the .htaccess. See the AuthUserFile, AuthName, AuthType and require. <BR>
Note: To use the <I>basicHttpAuthentication</I> parameter, then <I>AuthType</I> must contain <I>Basic</I>.
<BR>
The format for this parameter is <B><I>user:password</I></B>
<BR>
If empty (default value), this parameter is ignored (no authentication).
EOS
,
	'default' => '',
	'type' => 'string'
	)
,
'fileChooserIconFromFileContent' => array (
	'desc' => <<<EOS
If this parameter is set to true, the file chooser will replace the default file icons by an icon created
from the picture content.<BR>
Put it to 'false', to avoid this, as it can be memory consuming, with big directories.<BR>
<U>Note:</U> the icons are created in a separate thread, to avoid impact on the applet use.
EOS
,
	'default' => 'true',
	'type' => 'string'
	)
,
'fileChooserIconSize' => array (
	'desc' => <<<EOS
This parameter defines the size of the icon to be displayed in the file chooser, when a icon is
created from the file content. See the fileChooserIconFromFileContent parameter, here above.<BR>
EOS
,
	'default' => '50',
	'type' => 'int'
	)
,
'generateDefaultPictureTitle' => array (
	'desc' => <<<EOS
If set to a non 0 value (1 is the default value), the plugin will define a default title for each picture, based on the filename. All
underscores are removed. For instance, when uploading a <I>When_I_m_Happy.jpg</I> file, it will create a default
title <I>When I m Happy</I>.
<BR>
If 1, the picture title is left blank.  
EOS
	,
	'default' => '1',
	'type' => 'int'
	)
,
'highQualityPreview' => array (
	'desc' => <<<EOS
If set to a non 0 value, the JUpload will display better preview icons. But pictures will then display slower 
within the applet. This parameter applies when resizing the picture. Setting it to 1 creates smoother resized 
pictures It is different from the pictureCompressionQuality, that controls the jpeg compression of the files itself.
<BR>
The pictures sent to the server are always of the best available quality, whatever is the value of this parameter.<BR>
<BR>
<B>Since 2.6.0:</B> Default value is now 0, which allow much faster picture display.
EOS
	,
	'default' => '0',
	'type' => 'int'
	)
,
'jarPath' =>array (
	'desc' => <<<EOS
This parameter contains the path where the navigator should find the wjhk.jupload.jar file. This jar file contains 
the JUpload applet, and is absolutely necessary for this plugin.<BR>
It should contain one of the following values, in this order of priority:
 <DIR>
  <LI>Standard case: let this parameter empty. The default value is correct for standard Coppermine configuration.
  <LI>The absolute path of the jar file, ending with a slash, when your installation is not a standard 
  Coppermine installation. For instance, when Coppermine is itself a plugin of another tool.
  For instance: <I>/coppermine/plugins/jupload/</I>
  <LI>The relative path from the page calling the applet. Ending 
 </DIR> 
EOS
	,
	'default' => 'plugins/jupload/',
	'type' => 'string'
	)
,
'linkComment' => array (
	'desc' => <<<EOS
This parameter allows the admin to override the translated value of JUpload comment. This is the explanation text 
that is displayed when the mouse is over the JUpload button.<BR>
Take care that, if set, this text will be displayed whatever the user language is.<BR>
When this string is empty, the translated value is used. 
EOS
	,
	'default' => '',
	'type' => 'string'
	)
,
'linkKeepStandardUpload' => array (
	'desc' => <<<EOS
Indicates whether you want to keep the upload form, coming with Coppermine, or not. 0 indicates that the standard
upload link should disappear from the menu. 1 means that the two upload links are visible.  
EOS
	,
	'default' => '1',
	'type' => 'int'
	)
,
'linkTitle' => array (
	'desc' => <<<EOS
This parameter allows the admin to override the translated value of JUpload title. This is the text that is 
displayed on the JUpload button.<BR>
Take care that, if set, this text will be displayed whatever the user language is.<BR>
When this string is empty, the translated value is used. 
EOS
	,
	'default' => '',
	'type' => 'string'
	)
,
'maxChunkSize' => array (
	'desc' => <<<EOS
This value is the number of Kb that your webserver will allow for an upload. It may be smaller than the maximum
file size that you allow on your gallery.<BR>
<I>maxChunkSize</I> is a technical parameter, that allows you to override your webserver technical limitation
in upload file size.<BR>
Default is -1, meaning: no chunk. <BR>
If you know the maximum upload size of your webserver (or ISP), put it here. This limitation is often 2Mb (default
value in PHP configuration). Otherwise, let it empty.<BR>
Note: this value can be smaller than the effective server limitation. 
EOS
	,
	'default' => '-1',
	'type' => 'int'
	)
,
'maxFileSize' => array (
	'desc' => <<<EOS
This value is the maximum length of file, in kb, that you allow on your gallery, when uploading with JUpload. 
Default is the maximum file length defined in the Coppermine configuration. <BR>
You can put here a bigger value, than your Coppermine configuration max file, as this one must not be bigger than
the maximum upload size of your server. <BR>
If you put here a bigger value than the maximum upload size of your server, you should define a value for 
<I>maxChunkSize</I>.    <BR>
<U>Note:</U> When the upload is done in chunk mode, Coppermine internal code controls the size of the last upload, 
that is : the size of the last chunk, and not the size of the whole uploaded file, that may have been split into 
several chunk. 

EOS
	,
	'default' => (isset($CONFIG)) ? $CONFIG['max_upl_size'] : -1, //$CONFIG is not set, when called from ./plugins/jupload/configuration.php	
	'type' => 'int'
	)
,
'maxNonTransformedPictureSize' => array (
	'desc' => <<<EOS
This parameter is important to control to define who of the applet or the server resizes pictures biggers than the 
maximum picture size (in pixels) that you have defined in your Coppermine configuration. This is <U>important as the 
applet will resize pictures much slower than the GD (or ImageMagik) library on your server</U>. But, if the applet
resizes the picture, it will do it before upload. The upload is then much quicker, as the file to transmit will
probably be much smaller than your original picture file (4Mb to 400kb in my case).  
<BR>
This parameters applies only on pictures that the applet does not need to transform (that is: non rotated pictures).
In this case, the applet will resize or not the picture, depending on this parameter.
<BR>
To sum up:
<DIR>
<LI>if you put a value in this field:
	<DIR>
		<LI>Pictures that the user does not modify are resized or not, depending on this parameter.
		<LI>Pictures that the user modifies (picture rotation for instance) are transformed before upload, 
		and the tranformed picture file is automatically resized according to the current Coppermine configuration.
	</DIR>
<LI>if you do not put a value in this field, all pictures are resized, before upload, according to the 
Coppermine maxPictureSize.
</DIR>
<BR>If you put a 'big' value in this field. The consequence is:
<DIR>
	<LI>If the picture to upload is bigger than the Coppermine maxPictureSize
		<DIR>
		<LI>CPU time is much smaller, as Java is not really quick in picture work.
		<LI>Network traffic is bigger, as your original picture is sent to the server (instead of the resized picture) 
		</DIR>
	<LI>If the picture is less or equal to the Coppermine maxPictureSize
		<DIR>
		<LI>No change wether you use this parameter or not: there is no work to do on pictures to add them to
		your gallery. 
		</DIR>
</DIR>
<B>Be careful</B> that, if you put a big value here, you may encounter limitation with your server maxUploadSize.
You should take a look to the maxChunkSize and maxFileSize parameters.
The default behaviour is to provide the Coppermine maxPictureSize to the applet.   
EOS
	,
	'default' => -1,
	'type' => 'int'
	)
,
'pictureCompressionQuality' => array (
	'desc' => <<<EOS
This value represents the quality compression, for jpeg picture files. Bigger quality means higher quality
and bigger file. The default value corresponds to the Coppermine compression quality. 
EOS
	,
	'default' => '0.8',
	'type' => 'float'
	)
);


//####################################################################################################
//#################################  INTERNAL VARIABLES  #############################################
//####################################################################################################

$dateTime = getDate();

$configFileHeader = <<<EOS
<?php
/**
 * Caution: This file is generated from the jupload configuration page of JUpload.
 * 
 * You can update it: all modifications on value of valid Jupload parameters will be kept. Comments will be lost
 * if you save the configuration through the jupload configuration page.
 * 
 * To go to the jupload configuration page :
 * - Connect as an admin,
 * - Click on configuration, then General, then 'plugin management',
 * - Click on the 'Jupload Configuration' button that should appear, if JUpload is installed.
 * 
 * TODO: remove the html tags in this file. One day, perhaps ...
 * 
 */
 
EOS
;



$hint = <<<EOS
<HR>
<B><a name="Hints">Configuration hints</a></B>
<BR><BR>
You will find below the list of all JUpload configuration parameters, with a detailled explanation of each one. 
These parameters are stored in the plugins/jupload/user/config.inc.php file. It is kept when you upgrade to a 
new JUpload  version, through the plugin management page, or with FTP: this file is not packaged with JUpload 
releases.
<BR><BR>
You will find below <B>two typical configurations</B>:
<DIR
	<LI><B>Configuration to speed up the upload.</B> This configuration is a good replacement for <U>batch upload</U>, 
	and can <U>replace easily the xp_publish script</U>, that is no more available for Vista. The maximum 
	picture/file size is controled only by the maxPictureSize Coppermine configuration parameters. 
		<DIR>
			<LI>In Coppermine configuration, put in the maximum file size a value big enough to allow upload of 
			your bigger files, even if they are bigger than your server maxUploadSize. To upload files bigger than 
			the server maxUploadSize, you will have to use JUpload (and its chunk function, see below).
			<LI>In Jupload configuration:
			<DIR>
				<LI>maxChunkSize: put your server maxUploadSize (typically: 2Mb).
				<LI>maxFileSize: leave it empty.
				<LI>maxNonTransformedPictureSize: put a value larger than your picture max width and height (for 
				instance 4000) to prevent the applet to work on pictures that you want to upload 'as is'. Pictures 
				bigger than this limit will still be resized, before upload, to the maxPictureSize (in pixels) 
				defined in your gallery. 				 
			</DIR>
		</DIR>
	<LI><B>Standard configuration</B>. This configuration is the standard one, as it is compatible with all 
	existing configurations. It good enough for small upload (e.g.: less than 10 to 20 pictures). 
	<BR>Here is a descripion of what will happen if you do not update any
	JUpload parameters, relevant to the way upload works. The maximum picture/file size is controled these two  
	Coppermine configuration parameters: maxFileSize and maxPictureSize. 
		<DIR>
			<LI>In Coppermine configuration, put a value representative of the real maxFileSize you want to 
			allow.
			<LI>In Jupload configuration:
			<DIR>
				<LI>maxChunkSize: empty. All files are uploaded in one piece.
				<LI>maxFileSize: emptu. Respects the Coppermine maxFileSize configuration.
				<LI>maxNonTransformedPictureSize: empty. Pictures bigger than the Coppermine maxPictureSize are 
				resized before upload. This can take time, when you upload a lot of pictures, as Java is not as 
				good as native librairies (as GD) for heavy CPU work.		 
			</DIR>
		</DIR>
</DIR>
<U>Note: if you prepare your pictures before upload</U> and your pictures are already resized to your gallery
maximum width and height, then the above parameters should work the same way... Let the default parameters...

<HR>

EOS
;

//####################################################################################################
//##############################  CONFIG INITIALIZATION  #############################################
//####################################################################################################


/*
 * No more user specific include. This was not documented... Hope nobody used it   :-
 * 
//Let's call any user specific constant, like overriding of the 'standard' translation texts.
$user_inc = $juploadRootDirectory . 'user/user.inc.php';
if (file_exists($user_inc)) { 
	require($user_inc);
}

*/

/////////////////////////////////////////////////////////////////////////////////////////////////
//            CONFIGURATION STORAGE MIGRATION: config.inc.php -> Coppermine database
/////////////////////////////////////////////////////////////////////////////////////////////////
//This code is to be removed, when I can suppose that nobody still use 2.5.x or older version.
//Until JUpload v2.5.x, the configuration was stored in plugins/jupload/user/config/inc.php
//Since 2.6.0, the JUpload configuration is stored in the Coppermine database. The following
//lines check if this file exists. If yes, the configuration it contains is migrated toward the
//database. This will happen only once, as the file is then deleted.
$config_inc = "$juploadRootDirectory/user/config.inc.php";
if (file_exists($config_inc)) {
	//The file exists.
	//Let's migrate the config parameters to the config table
	migrateConfigFileToConfigTable();
}
/////////////////////////////////////////////////////////////////////////////////////////////////



//Let's read the current configuration from the config table: all existing parameters have been read
//from the config table, and stored in the $CONFIG array.
initJuploadConfig();


//####################################################################################################
//#################################    FUNCTIONS    ##################################################
//####################################################################################################


/**
 * Writes the list of available parameters, with a link to the coresponding section in this page.
 * It allows a quick view of all available parameters, and a quick access to each part of the page.
 */
function getTableOfContent() {
	global $JUploadParamList;

	$return = "";
	$return .= "<B>Table of content:</B>\n";
	$return .= " <DIR>\n";
	$return .= "  <LI><a href='#Hints'>Configuration hints</a>\n";
	foreach ($JUploadParamList as $paramName => $param) {
		//$return .= "  <LI><a href='#${param['name']}'>config parameter <I>${param['name']}</I></a>\n";
		$return .= "  <LI><a href='#$paramName'>config parameter <I>$paramName</I></a>\n";
	}
	$return .= " </DIR>\n";
	
	return $return;
}//getTableOfContent


/**
 * Initialization of the JUPLOAD_CONFIG array, from the existing parameters in $CONFIG. The $CONFIG array
 * contains the config table data. All parameter names in this table are prefixed by the content of the
 * $parameterPrefix variable, to be sure that there is no collision with Coppermine internal config parameters.
 * 
 * $useDefaultValue indicates whether default value should be used or not.
 */
function initJuploadConfig($useDefaultValue = true) {
	global $CONFIG, $JUPLOAD_CONFIG, $JUploadParamList, $parameterPrefix;

//KO: les paramtres ne sont apparemment pas correctement lus  ($JUploadParamList vide ?)

	//For all known JUpload parameters: if it's set in the config table, we use this value. Otherwiser, we user
	//the default value for this parameter.
	foreach($JUploadParamList as $paramName=>$param) {
		if (isset($CONFIG[$parameterPrefix . $paramName])) {
			$JUPLOAD_CONFIG[$paramName] = $CONFIG[$parameterPrefix . $paramName];
			//echo("$param_name: default(${JUPLOAD_CONFIG[$paramName]})<BR>");
		} else if ($useDefaultValue) {
			$JUPLOAD_CONFIG[$paramName] = $param['default'];
			//echo("$param_name: default(${param['default']})<BR>");
		}
	}//foreach($JUploadParamList)
	
	//Specific test for some parameters
	
	//alwaysVisible can only be 0, 1 or 2.
	if ($JUPLOAD_CONFIG['alwaysVisible'] != 0 
	 && $JUPLOAD_CONFIG['alwaysVisible'] != 1 
	 && $JUPLOAD_CONFIG['alwaysVisible'] != 2) 
	{
		$JUPLOAD_CONFIG['alwaysVisible'] = $JUploadParamList['alwaysVisible']['default'];
	}
}

function migrateConfigFileToConfigTable() {
	global $CONFIG, $JUPLOAD_CONFIG, $config_inc;
	
	//First: let's read the 'old' config file.
	unset($JUPLOAD_CONFIG);
	require($config_inc);
	echo("Migrating the JUpload configuration: the $config_inc is not more used. " .
			"Data is now stored in the Coppermine database.<BR>" .
			"<B>This messsage (and migration) will occur only once.</B><BR>");

	//Then: save the config in the database.
	//No need to reload the config, as the one in the file was Ok.  
	saveJuploadConfigParamInCoppermineDatabase($JUPLOAD_CONFIG);
	
	//Now, we remove this old configuration file.
	unlink($config_inc);
	
	//That's all.	
}


/**
 * writeJuploadConfigFile generates the Jupload config file from the posted data.
 */ 
function writeJuploadConfigFile() {
	global $JUploadParamList, $JUPLOAD_CONFIG, $configFileHeader, $hint;
	$htmlResult = '';  //This string will remain empty if everything is Ok.

	$h = fopen('plugins/jupload/user/config.inc.php', 'w');

	if (!$h) {
		$htmlResult = "<FONT color=red>Erreur while opening the file '$filename'</FONT>";
	} else {
		$dateTime = date('j M Y  H:i');
		fwrite($h, $configFileHeader);
		//Then, we write the list of parameters, a kind of 'table of content', to allows quick 
		//access to each parameter
		fwrite($h, "/*\n");
		fwrite($h, getTableOfContent());
		fwrite($h, "*/\n");
		fwrite($h, <<<EOS
/*
$hint
*/

EOS
);
		foreach ($JUploadParamList as $paramName=>$param) {
			//Default value: a beautiful empty string!
			$comment_if_undefined = '//';
			$val = '';			
			if ($param['type'] == 'int') {				
				if (isset($_POST[$paramName])  &&  $_POST[$paramName] != '') {
					$val = (int)$_POST[$paramName];
					$comment_if_undefined = '';
				}
			} else if ($param['type'] == 'float') {
				if (isset($_POST[$paramName])  &&  $_POST[$paramName] != '') {
					$val = (float)$_POST[$paramName];
					$comment_if_undefined = '';
				}
			} else {
				//Let's suppose it's a string
				if (isset($_POST[$paramName])  &&  $_POST[$paramName] != '') {
					$val = '\'' . str_replace('\'', '\\\'', $_POST[$paramName]) . '\'';
					$comment_if_undefined = '';
				}
			}

			fwrite($h, <<<EOS

/*
${param['desc']}
Default value is '${param['default']}'		
*/
$comment_if_undefined\$JUPLOAD_CONFIG['$paramName'] = $val;

EOS
);
		}
	}
	
	return $htmlResult;
}


/**
 * Save all config parameters defined in $JUploadParamList, that do not have default value in the config table.
 * All other parameters from $JUploadParamList are removed.
 * Note: Coppermine erases the config table when restauring the default configuration, which is nice also 
 * for JUpload..
 * 
 * The configuration to store can be store in any array. The default one is the $_POST superglobal array. But, it
 * seems that $_POST can not be assigned to an array. So, it's handled manually in the foreach.
 */
function saveJuploadConfigParamInCoppermineDatabase(&$paramsToStore) {
	global $parameterPrefix, $JUploadParamList, $CONFIG;
/*
	//$newValue will contain the value which should be set into the JUpload configuration for the current parameter.
	$newValue = '';
	
	foreach ($JUploadParamList as $paramName=>$param) {
		//Apparently, $_POST can be assigned to a variable, and can not be passed as an argument.
		//So we manage this manually:
		unset($newValue);
		if (!$paramsToStore) {
			echo("paramsToStore: false<BR>");
			//Default behaviour: we use the $_POST array.
			if (isset($_POST[$paramName])) {
				$newValue = $_POST[$paramName];
			}
		} else {
			//We use the given array.
			if (isset($paramsToStore[$paramName])) {
				$newValue = $paramsToStore[$paramName];
			}
		}
		echo("paramName: $paramName=$newValue<BR>");
		//Default value: a beautiful empty string!
		$val = '';			
		if ($param['type'] == 'int') {				
			if (isset($newValue)  &&  $newValue != '') {
				$val = (int)$newValue;
				$comment_if_undefined = '';
			}
		} else if ($param['type'] == 'float') {
			if (isset($newValue)  &&  $newValue != '') {
				$val = (float)$newValue;
				$comment_if_undefined = '';
			}
		} else {
			//Let's suppose it's a string
			if (isset($newValue)  &&  $newValue != '') {
				$val = '\'' . str_replace('\'', '\\\'', $newValue) . '\'';
				$comment_if_undefined = '';
			}
		}

		//To check the content of the config table, we trust the $CONFIG variable. Won't work
		//if someone updated the config table while the server is managing a submit from the config page.
		//Let's say it's not possible...
		
		//If this parameter was set in the config table
		if (isset($CONFIG[$parameterPrefix . $paramName])) {
			//If the value changed, we store it
			if ($CONFIG[$parameterPrefix . $paramName] != $newValue) {
				//If the new value is the default one, we delete the parameter from the config table.
				if ($newValue == $param['default']) {
					cpg_db_query("DELETE FROM {$CONFIG['TABLE_CONFIG']} WHERE name='$parameterPrefix{$paramName}'");
				} else {
					cpg_db_query("UPDATE {$CONFIG['TABLE_CONFIG']} SET value='"
						. str_replace('\'', '\\\'', $newValue)
						. "' WHERE name='$parameterPrefix$paramName'");
				}
			}				
		} else {			
			//The parameter was not set in the config table. If the post is not the default value,
			//we store it (insert).
			if ($newValue != $param['default']  &&  $newValue != '') {
				cpg_db_query("INSERT INTO {$CONFIG['TABLE_CONFIG']} (name, value) VALUES ('$parameterPrefix$paramName', '"
					. str_replace('\'', '\\\'', $newValue)
					. "')"
					);
			}
		} 
	}//saveJuploadConfigParamInCoppermineDatabase
*/
	foreach ($JUploadParamList as $paramName=>$param) {
		/*
		 * The following code is of no interest, as we now store the configuraton into the
		 * CONFIG table

		//Default value: a beautiful empty string!
		$val = '';			
		if ($param['type'] == 'int') {				
			if (isset($paramsToStore[$paramName])  &&  $paramsToStore[$paramName] != '') {
				$val = (int)$paramsToStore[$paramName];
				$comment_if_undefined = '';
			} else if (isset($paramsToStore[$paramName])  &&  $paramsToStore[$paramName] != '') {
				//We replace the 'null' by the default one, as null is not allowed for int.
				$val = (int)$paramsToStore[$paramName];
			}
		} else if ($param['type'] == 'float') {
			if (isset($paramsToStore[$paramName])  &&  $paramsToStore[$paramName] != '') {
				$val = (float)$paramsToStore[$paramName];
				$comment_if_undefined = '';
			}
		} else {
			//Let's suppose it's a string
			if (isset($paramsToStore[$paramName])  &&  $paramsToStore[$paramName] != '') {
				$val = '\'' . str_replace('\'', '\\\'', $paramsToStore[$paramName]) . '\'';
				$comment_if_undefined = '';
			}
		}
		*/

		//To check the content of the config table, we trust the $CONFIG variable. Won't work
		//if someone updated the config table while the server is managing a submit from the config page.
		//Let's say it's not possible...
		
		//If this parameter was set in the config table
		if (isset($CONFIG[$parameterPrefix . $paramName])) {
			//If the value changed, we store it
			if ($CONFIG[$parameterPrefix . $paramName] != $paramsToStore[$paramName]) {
				//If the new value is the default one, we delete the parameter from the config table.
				//Also: we do not accept empty value. Considered as default value.
				if ($paramsToStore[$paramName]==$param['default'] || $paramsToStore[$paramName]=='') {
					cpg_db_query("DELETE FROM {$CONFIG['TABLE_CONFIG']} WHERE name='$parameterPrefix{$paramName}'");
				} else {
					cpg_db_query("UPDATE {$CONFIG['TABLE_CONFIG']} SET value='"
						. str_replace('\'', '\\\'', $paramsToStore[$paramName])
						. "' WHERE name='$parameterPrefix$paramName'");
				}
			}				
		} else {			
			//The parameter was not set in the config table. If the post is not the default value,
			//we store it (insert).
			if ($paramsToStore[$paramName] != $param['default']  &&  $paramsToStore[$paramName] != '') {
				cpg_db_query("INSERT INTO {$CONFIG['TABLE_CONFIG']} (name, value) VALUES ('$parameterPrefix$paramName', '"
					. str_replace('\'', '\\\'', $paramsToStore[$paramName])
					. "')"
					);
			}
		} 
	}//saveJuploadConfigParamInCoppermineDatabase
	
}